# Python imports

# Lib imports
from gi.repository import GLib

# Application imports
# from libs.dto.lsp_messages import LEN_HEADER, TYPE_HEADER, get_message_str, get_message_obj, definition_query, references_query, symbols_query
from libs.dto.lsp_messages import didopen_notification



class LSPControllerEvents:
    def _lsp_did_open(self, data: dict):
        method = data["method"]
        params = didopen_notification["params"]

        params["textDocument"]["uri"]        = data["uri"]
        params["textDocument"]["languageId"] = data["language_id"]
        params["textDocument"]["text"]       = data["text"]

        GLib.idle_add( self.send_notification, method, params )

    def _lsp_did_save(self, data: dict):
        # self.send_notification(method, params)
        ...

    def _lsp_did_close(self, data: dict):
        # self.send_notification(method, params)
        ...

    def _lsp_did_change(self, data: dict):
        method      = data["method"]
        language_id = data["language_id"]
        uri         = data["uri"]
        text        = data["text"]
        line        = data["line"]
        column      = data["column"]

        self.send_notification(method, params)
        # return "{'notification':'some kind of response'}"

    def _lsp_goto(self, data: dict):
        method      = data["method"]
        language_id = data["language_id"]
        uri         = data["uri"]
        line        = data["line"]
        column      = data["column"]

        self._client_send_request(method, uri, line, column)
        # return "{'response':'some kind of response'}"

    def _lsp_completion(self, data: dict):
        method      = data["method"]
        language_id = data["language_id"]
        uri         = data["uri"]
        line        = data["line"]
        column      = data["column"]

        # self._client_send_request(method, uri, line, column)