# Python imports

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# Application imports
from .workspace_folder_choser_button import WorkspaceFolderChoserButton



class TopButtonBox(Gtk.ButtonBox):
    def __init__(self):
        super(TopButtonBox, self).__init__()

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()

        self.show_all()


    def _setup_styling(self):
        ctx = self.get_style_context()
        ctx.add_class("top-button-box")

        self.set_homogeneous(True)

    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        event_system.subscribe("update-message-id-lbl", self.update_message_id_lbl)

    def _load_widgets(self):
        box                       = Gtk.Box()
        self.message_id_lbl       = Gtk.Label(label = "Message ID: 0")
        self.folder_choser_lbl    = Gtk.Label(label = "Workspace Folder:  ")
        self.workspace_choser_btn = WorkspaceFolderChoserButton()

        box.add(self.folder_choser_lbl)
        box.add(self.workspace_choser_btn)
        self.add(self.message_id_lbl)
        self.add(box)

    def update_message_id_lbl(self, id: int):
        self.message_id_lbl.set_label(f"Message ID: {id}")

    def get_workspace_path(self):
        return self.workspace_choser_btn.get_workspace_path()

    def get_workspace_uri(self):
        return self.workspace_choser_btn.get_workspace_uri()
