# Python imports
import json

# Lib imports

# Application imports
from .lsp_message_structs import MessageEncoder



LEN_HEADER  = "Content-Length: "
TYPE_HEADER = "Content-Type: "



def get_message_str(data: dict) -> str:
    return json.dumps(data, separators = (',', ':'), indent = 4, cls = MessageEncoder)

def get_message_obj(data: str):
    return json.loads(data)



# Request type formatting
# https://github.com/microsoft/multilspy/blob/main/src/multilspy/language_server.py#L417
content_part = {
	"method": "textDocument/definition",
	"params": {
	    "textDocument": {
            "uri": "file:///",
            "languageId": "python3",
            "version": 1,
            "text": ""
	    },
	    "position": {
	        "line": 5,
            "character": 12,
            "offset": 0
	    }
	}
}

didopen_notification = {
	"method": "textDocument/didOpen",
	"params": {
	    "textDocument": {
            "uri": "file://<path>",
            "languageId": "python3",
            "version": 1,
            "text": ""
	    }
	}
}



definition_query = {
	"method": "textDocument/definition",
	"params": {
	    "textDocument": {
            "uri": "file:///home/abaddon/Coding/Projects/Active/Python_Projects/000_Usable/gtk/LSP-Manager/src/core/widgets/lsp_message_box.py",
            "languageId": "python3",
            "version": 1,
            "text": ""
	    },
	    "position": {
	        "line": 5,
            "character": 12,
            "offset": 0
	    }
	}
}

references_query = {
    "method": "textDocument/references",
    "params": {
        "context": {
            "includeDeclaration": False
        },
	    "textDocument": {
            "uri": "file:///home/abaddon/Coding/Projects/Active/Python_Projects/000_Usable/gtk/LSP-Manager/src/core/widgets/lsp_message_box.py",
            "languageId": "python3",
            "version": 1,
            "text": ""
	    },
	    "position": {
	        "line": 30,
            "character": 13,
            "offset": 0
	    }
	}
}


symbols_query = {
	"method": "textDocument/documentSymbol",
	"params": {
	    "textDocument": {
            "uri": "file:///home/abaddon/Coding/Projects/Active/Python_Projects/000_Usable/gtk/LSP-Manager/src/core/widgets/lsp_message_box.py",
            "languageId": "python3",
            "version": 1,
            "text": ""
	    }
	}
}